/**
 * A program demonstrating some simple functions.
 */
#include <iostream>

using namespace std;

double division (int, int);
void introduction ();
void printReport (int, int, int);
int readGrade ();
int sum (int num1, int num2);

int main ()
{
	int grade, total = 0, number = 0;
	double average;
	
	//Printing out some comments.
	introduction ();
	
	//Reading in one grade.
	grade = readGrade ();
	//Adding to the total grade.
	total = sum (grade, total);
	//Increasing the number of records.
	number++;
	//Printing current report.
	printReport (grade, total, number);
	
	grade = readGrade ();
	total = sum (grade, total);
	number++;
	printReport (grade, total, number);
		
	grade = readGrade ();
	total = sum (grade, total);
	number++;
	printReport (grade, total, number);
		
	grade = readGrade ();
	total = sum (grade, total);
	number++;
	printReport (grade, total, number);
		
	cout << "The total grade for " << number << " people is : " << total << endl;
	cout << "The average of the grade is : " << division (total, number) << endl;
	
	return 0;
}

/**
 * Prints out several lines to the screen.
 * No parameters needed, no return type.
 */
void introduction ()
{
	cout << "This example shows several simple functions including :" << endl;
	cout << "1. No parameters or return value - \"void introduction ()\"" << endl
		 << "2. Some parameters but no return value - \"void printReport (int, int, int)\"" << endl
		 << "3. Some parameters and return value - \"int sum (int grade1, int grade2)\"" << endl;
}

/**
 * Reads in an integer from keyboard.
 *
 * @return the integer that reads in.
 */
int readGrade ()
{
	int grade;
	cout << "Please input the grade ";
	cin >> grade;
	return grade;
}

/**
 * Prints out current report to the screen.
 *
 * @param last read in grade.
 * @param total grade so far.
 * @param number of inputs.
 */
void printReport (int grade, int total, int number);
{
	cout << "The last read in grade is :" << grade << end;
	cout << "The total grade so far is :" << total << endl;
	cout << "There are " << number << "of inputs so far.\n";
}

/**
 * Gets the sum of two integers.
 *
 * @param one of the integer.
 * @param the other integer.
 *
 * @return the sum of two integers that pass in the function.
 */
int sum (int grade1, int grade2)
{
	return grade1 + grade2;
}

/**
 * Gets the division of two integers.
 * Not a good example for average, just to show return double and type casting.
 *
 * @param one of the integer.
 * @param the other integer.
 *
 * @return their division in double.
 */
double division (int total, int number)
{
	return (double)total / number;
}